//+------------------------------------------------------------------+
//|                                             Quantum_Channals.mq4 |
//|                              Copyright  2009, Nazariy S. (WWer) |
//|                   E-mail: wholewer@gmail.com, Skype: nazariy1309 |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, Nazariy S. (WWer)"
#property link      "E-mail: wholewer@gmail.com, Skype: nazariy1309"

extern bool   show_abc=true;
extern double q=1.414213562373095;

//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
  {
//----
   bool     only_alpha;
   double   R1=0.0,
            R2=0.0,
            R=0.0,
            r=0.0,
            c=0.0,
            n=0.0,
            //----
            n_a=0.0,
            n_b=0.0,
            n_g=0.0,
            n_abc=0.0,
            delta_Current=0.0,
            delta_Alpha=0.0,
            delta_Betta=0.0,
            delta_Gamma=0.0,
            delta_ABC=0.0;
            //----
   datetime t1=0,
            t2=0,
            t=0;
   string   name="";
   
   //----  ""  ( ""   )
   Del_Objects();

   //----    
   for(int i=ObjectsTotal()-1; i>=0; i--) {
       name=ObjectName(i);
       if(StringLen(name)<=10)
          continue;
       if(StringSubstr(name,0,10)=="Trendline ")
          break;
      }
   if(StringSubstr(name,0,10)!="Trendline ")
      for(i=ObjectsTotal()-1; i>=0; i--) {
          name=ObjectName(i);
          if(StringLen(name)<4)
             continue;
          if(name=="most")
             break;
         }
   else ObjectDelete("most");
   t1=ObjectGet(name,OBJPROP_TIME1);
   R1=Close[iBarShift(0,0,t1,true)];
   t2=ObjectGet(name,OBJPROP_TIME2);
   R2=Close[iBarShift(0,0,t2,true)];
   
   //----
   if(t2<t1) {
      t=t1;
      t1=t2;
      t2=t;
      //----
      R=R1;
      R1=R2;
      R2=R;
     }
   R=MathAbs(R2-R1);
   t=MathAbs(t2-t1);
   r=MathAbs(Close[0]-Close[1]);
   c=r;
   n=c*t/R;
   only_alpha=Qn(R, r, n, q,/***/n_a, n_b, n_g, n_abc);
   
   //----
   ObjectDelete(name);
   ObjectCreate("most",OBJ_TREND,0,t1,R1,t2,R2);
   ObjectSet("most",OBJPROP_WIDTH,2);
   ObjectSet("most",OBJPROP_COLOR,Yellow);
   ObjectSet("most",OBJPROP_RAY,false);
   
   //----
   delta_Current=q*r*n;
   delta_Alpha=q*r*n_a;
   delta_Betta=q*r*n_b;
   delta_Gamma=q*r*n_g;
   delta_ABC=q*r*n_abc;
   
   //----
   int mn=-1;
   if(R2>R1)
      mn=1;
      ObjectCreate("Alpha_up",OBJ_TREND,0, t2-1000, R2 + mn*1000*r/n_a, t2, R2);
      ObjectSet("Alpha_up",OBJPROP_WIDTH,1);
      ObjectSet("Alpha_up",OBJPROP_COLOR,Red);
      ObjectSet("Alpha_up",OBJPROP_RAY,true);
      //----
      ObjectCreate("Alpha_down",OBJ_TREND,0, t1-1000, R1 + mn*1000*r/n_a, t1, R1);
      ObjectSet("Alpha_down",OBJPROP_WIDTH,1);
      ObjectSet("Alpha_down",OBJPROP_COLOR,Red);
      ObjectSet("Alpha_down",OBJPROP_RAY,true);
      //#######
      if(only_alpha) {
         ObjectCreate("Betta_up",OBJ_TREND,0, t2-1000, R2 - mn*1000*r/n_b, t2, R2);
         ObjectSet("Betta_up",OBJPROP_WIDTH,1);
         ObjectSet("Betta_up",OBJPROP_COLOR,Green);
         ObjectSet("Betta_up",OBJPROP_RAY,true);
         //----
         ObjectCreate("Betta_down",OBJ_TREND,0, t1-1000, R1 - mn*1000*r/n_b, t1, R1);
         ObjectSet("Betta_down",OBJPROP_WIDTH,1);
         ObjectSet("Betta_down",OBJPROP_COLOR,Green);
         ObjectSet("Betta_down",OBJPROP_RAY,true);
         //#######
         ObjectCreate("Gamma_up",OBJ_TREND,0, t2-1000, R2 - mn*1000*r/n_g, t2, R2);
         ObjectSet("Gamma_up",OBJPROP_WIDTH,1);
         ObjectSet("Gamma_up",OBJPROP_COLOR,Blue);
         ObjectSet("Gamma_up",OBJPROP_RAY,true);
         //----
         ObjectCreate("Gamma_down",OBJ_TREND,0, t1-1000, R1 - mn*1000*r/n_g, t1, R1);
         ObjectSet("Gamma_down",OBJPROP_WIDTH,1);
         ObjectSet("Gamma_down",OBJPROP_COLOR,Blue);
         ObjectSet("Gamma_down",OBJPROP_RAY,true);
        }
      if(n_abc==0.0) n_abc=2*n; //################################
      if(show_abc) {
         ObjectCreate("ABC_up",OBJ_TREND,0, t2-1000, R2 - mn*1000*r/n_abc, t2, R2);
         ObjectSet("ABC_up",OBJPROP_WIDTH,1);
         ObjectSet("ABC_up",OBJPROP_COLOR,Violet);
         ObjectSet("ABC_up",OBJPROP_RAY,true);
         //----
         ObjectCreate("ABC_down",OBJ_TREND,0, t1-1000, R1 - mn*1000*r/n_abc, t1, R1);
         ObjectSet("ABC_down",OBJPROP_WIDTH,1);
         ObjectSet("ABC_down",OBJPROP_COLOR,Violet);
         ObjectSet("ABC_down",OBJPROP_RAY,true);
        }
   
   Comment("Current\t",n,"\n",
           "Alpha  ",n_a,"\n",
           "Betta  ",n_b,"\n",
           "Gamma  ",n_g,"\n",
           "ABC    ",n_abc,"\n",
           "-------------\n",
           "delta Alpha  ",delta_Alpha,"\n",
           "delta Betta  ",delta_Betta,"\n",
           "delta Gamma  ",delta_Gamma,"\n",
           "delta ABC    ",delta_ABC);
   
   Print("Error  ",GetLastError());
//----
   return(0);
  }
//+------------------------------------------------------------------+

bool Qn(double R,double r, double n, double q,/***/double& n_a, double& n_b, double& n_g, double& n_abc)
  {
   double d=R/(2*q*r),
          d2=d*d,
          sqrt=0.0;
   
   n_a=d+MathSqrt(d2+2*d*n);    // alpha
   if(d2>=2*d*n) {
      sqrt=MathSqrt(d2-2*d*n);
      n_b=d+sqrt;               // betta
      n_g=d-sqrt;               // gamma
      n_abc=2*n;                // abc
      return(true);
     }
   return(false); //  false     
  }

void Del_Objects()
  {
   int    i=ObjectsTotal()-1;
   string name="",
          substr="",
          names[]={"ABC_","Alph","Bett","Gamm"};
   
   for(; i>=0; i--)
      {
       name=ObjectName(i);
       if(StringLen(name)<4)
          continue;
       substr=StringSubstr(name,0,4);
       for(int j=0; j<4; j++)
           if(substr==names[j]) {
              ObjectDelete(name);
              break;
             }
      }
  }